void setscreenmode(void)
{
asm{mov ax,13h;int 010h;}
}



void line(int x1,int y1,int x2,int y2,char col)
{
int x,y,xlength,ylength,dx,dy;
float xslope,yslope;
  xlength=abs (x1-x2);
  if ((x1-x2)<0) dx=-1;
  if ((x1-x2)==0) dx=0;
  if ((x1-x2)>0) dx=+1;
  ylength=abs (y1-y2);
  if ((y1-y2)<0) dy=-1;
  if ((y1-y2)==0) dy=0;
  if ((y1-y2)>0) dy=+1;
  if (dy==0)
	{
    if (dx<0) for (x=x1;x<=x2;x++) putpixel (x,y1,col);
    if (dx>0) for (x=x2;x<=x1;x++) putpixel (x,y1,col);
    return;
    }
  if (dx==0)
    {
    if (dy<0) for (y=y1;y<=y2;y++) putpixel (x1,y,col);
    if (dy>0) for (y=y2;y<=y1;y++) putpixel (x1,y,col);
    return;
    }
  xslope=(float) xlength/ylength;
  yslope=(float) ylength/xlength;
  if (((float)yslope/xslope<1) && ((float)yslope/xslope>-1))
   {
    if (dx<0) for(x=x1;x<=x2;x++)
	      {
		   y= yslope*x;
		   putpixel (x,y,col);
	      }
    if (dx>0) for(x=x2;x<=x2;x++)
	      {
		   y= yslope*x;
		   putpixel (x,y,col);
	      }
  }
  else
  {
    if (dy<0) for (y=y1;y<=y2;y++)
	      {
	      x= xslope*y;
	      putpixel (x,y,col);
	      }
    if (dy>0) for(y=y2;y<=y1;y++)
	      {
	      x= xslope*y;
	      putpixel (x,y,col);
	      }
  }
}


int getpixel(int x,int y,int where)
{
int color;
asm{
	cli;
    push ax;
    push bx
    push dx
    push ds
    push si
    mov     ax,[where];
    mov     ds,ax;
    mov     bx,[x];
    mov     dx,[y];
    mov     si,bx;      //si=x
    mov     bx, dx;	//bx=y dx=y
    shl     dx, 8;      //dx=y*256
    shl     bx, 6;      //bx=y*64
    add     dx, bx;     //dx=dx+bx=y*320
    add     si, dx;     //si=x+y*320
    lodsb;
    mov ah,0
    mov color,ax;
    pop si
    pop ds
    pop dx
    pop bx
    pop ax

    }
    return(color);
}


void putpixel(int x,int y,char col,int where)
{
asm{mov     ax,[where];
    mov     es,ax;
    mov     bx,[x];
    mov     dx,[y];
    mov     di,bx;
    mov     bx, dx;
    shl     dx, 8;
    shl     bx, 6;
    add     dx, bx;
    add     di, dx;
    mov     al, [col];
    stosb;
    }
}

void rectangle(int x1,int y1,int x2,int y2,char col)
{
line(x1,y1,x1,y2,col);
line(x1,y2,x2,y2,col);
line(x2,y2,x2,y1,col);
line(x2,y1,x1,y1,col);
}

void bar ( int x1,int y1,int x2,int y2, char col)
{
int j;
for(j=y1;j<=y2;j++)
	line(x1,j,x2,j,col);
}
