#include <time.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "flames.h"
#include "cglib.cpp"



class flames
{
private:
	unsigned char board[180][156],backupboard[180][156];
	void calculate_frame(void);
	void plot_frame(void);
public:
	int boardwidth,boardheight,flame_x,flame_y;
	void generate(void);
};


void flames::generate(void)
{
int i,j;
int pal_darkness = 2;
unsigned char fpal[256][3];
setscreenmode();
for(i=0;i<256;i++)
	SETCOLORPALETTE(i,pal[i][0],pal[i][1],pal[i][2]);
randomize();
for (i=0;i<boardwidth;i++)
	for (j=0;j<boardheight;j++)
		backupboard[i][j]=board[i][j]=0;
while(!kbhit())
{
for(i=0;i<boardwidth;i++)
	{
	backupboard[i][boardheight-2]=random(255);
	backupboard[i][boardheight-1]=random(255);
	backupboard[i][boardheight-3]=random(255);
	i=i;
	}
	calculate_frame();
	plot_frame();
}
}


void flames::calculate_frame(void)
{
int i,j,temp;
for (i=2;i<boardwidth-2;i++)
	for (j=2;j<boardheight-2;j++)
		{
		temp=(backupboard[i-1][j+1]+backupboard[i+1][j+1]+
			backupboard[i-1][j+2]+backupboard[i][j+2]+
			backupboard[i+1][j+2])/5-6;
		board[i][j]=temp*(temp>0);
		}

for (i=0;i<boardwidth;i++)
	for(j=0;j<boardheight;j++)
		backupboard[i][j]=board[i][j];

}

void flames::plot_frame()
{
int i,j;
for (i=4;i<(boardwidth-4);i++)
	for (j=4;j<boardheight-7;j++)
		putpixel(i+flame_x,j+flame_y,board[i][j]);
}


void main(void)
{
class flames flame;
flame.boardwidth=100;flame.boardheight=70;
flame.flame_x=108;flame.flame_y=34;
flame.generate();
}


